import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';
import { LoadingController, ActionSheetController } from 'ionic-angular';
import { TreeViewService } from '../services/tree-view.service';
var TreeViewComponent = /** @class */ (function () {
    function TreeViewComponent(navCtrl, loadingCtrl, actionSheetCtrl, treeViewService) {
        this.navCtrl = navCtrl;
        this.loadingCtrl = loadingCtrl;
        this.actionSheetCtrl = actionSheetCtrl;
        this.treeViewService = treeViewService;
        this.nameSort = 'arrow-down';
    }
    TreeViewComponent.prototype.ngOnInit = function () {
        // this.presentLoading();
    };
    TreeViewComponent.prototype.presentLoading = function () {
        var loader = this.loadingCtrl.create({
            content: 'Loading files...',
            duration: 3000
        });
        loader.present();
    };
    TreeViewComponent.decorators = [
        { type: Component, args: [{
                    selector: 'tree-view-component',
                    template: "\n  <div class=\"grid-container\">\n    <div class=\"main\">\n      <tree-view-history-component></tree-view-history-component>\n      <tree-view-header-component></tree-view-header-component>\n      <tree-view-list-component></tree-view-list-component>\n    </div>\n    <div class=\"sidebar\">\n      <tree-view-description-component></tree-view-description-component>\n    </div>\n  </div>\n  ",
                    styles: ["\n  .grid-container {\n    display: grid;\n    position: absolute;\n    height: 100%;\n    width: 100%;\n    grid-template-columns: auto 300px;\n  }\n\n  .main {\n    display: grid;\n    padding: 0px 15px 15px 15px;\n    grid-template-rows: 40px 40px auto;\n    overflow-y: auto;\n    border-right: 1px solid #f2f2f2;\n  }\n\n  .sidebar {\n    display: grid;\n    height: 100%;\n  }\n  "],
                },] },
    ];
    /** @nocollapse */
    TreeViewComponent.ctorParameters = function () { return [
        { type: NavController },
        { type: LoadingController },
        { type: ActionSheetController },
        { type: TreeViewService }
    ]; };
    return TreeViewComponent;
}());
export { TreeViewComponent };
//# sourceMappingURL=tree-view.component.js.map