import { StateContext } from '@ngxs/store';
import { Object } from './tree-view.model';
import { GenerateTree, SortTree, GenerateHistory, ObjectSelect } from './tree-view.actions';
import { ObjectSortingService } from '../services/object-sorting.service';
export interface TreeViewStateModel {
    objects: Object[];
    history: String[];
    objectSelected: Object;
}
export declare class TreeViewState {
    private objectSorting;
    constructor(objectSorting: ObjectSortingService);
    static getObjects(state: TreeViewStateModel): Object[];
    static getHistory(state: TreeViewStateModel): String[];
    static getObjectSelected(state: TreeViewStateModel): Object;
    generateTree({getState, patchState}: StateContext<TreeViewStateModel>, {object, directory}: GenerateTree): void;
    sortTree({getState, patchState}: StateContext<TreeViewStateModel>, {field}: SortTree): void;
    generateHistory({getState, patchState}: StateContext<TreeViewStateModel>, {object, directory}: GenerateHistory): void;
    objectSelect({getState, patchState}: StateContext<TreeViewStateModel>, {object}: ObjectSelect): void;
}
