var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { State, Action, Selector } from '@ngxs/store';
import { GenerateTree, SortTree, GenerateHistory, ObjectSelect, } from './tree-view.actions';
import { ObjectSortingService } from '../services/object-sorting.service';
var TreeViewState = /** @class */ (function () {
    function TreeViewState(objectSorting) {
        this.objectSorting = objectSorting;
    }
    TreeViewState.getObjects = function (state) {
        return state.objects;
    };
    TreeViewState.getHistory = function (state) {
        return state.history;
    };
    TreeViewState.getObjectSelected = function (state) {
        console.log('here');
        return state.objectSelected;
    };
    TreeViewState.prototype.generateTree = function (_a, _b) {
        var getState = _a.getState, patchState = _a.patchState;
        var object = _b.object, directory = _b.directory;
        var state = getState();
        var objects = object.filter(function (a) { return a.parent === directory; });
        patchState({
            objects: this.objectSorting.sortObjects('name-asc', objects),
            history: state.history.concat([directory]),
        });
    };
    TreeViewState.prototype.sortTree = function (_a, _b) {
        var getState = _a.getState, patchState = _a.patchState;
        var field = _b.field;
        var state = getState();
        patchState({
            objects: this.objectSorting.sortObjects(field, state.objects),
        });
    };
    TreeViewState.prototype.generateHistory = function (_a, _b) {
        var getState = _a.getState, patchState = _a.patchState;
        var object = _b.object, directory = _b.directory;
        var state = getState();
        var index = state.history.indexOf(directory) + 1;
        var objects = object.filter(function (a) { return a.parent === directory; });
        patchState({
            objects: this.objectSorting.sortObjects('name-asc', objects),
            history: state.history.slice(0, index),
        });
    };
    TreeViewState.prototype.objectSelect = function (_a, _b) {
        var getState = _a.getState, patchState = _a.patchState;
        var object = _b.object;
        var state = getState();
        patchState(__assign({}, state, { objectSelected: object }));
    };
    __decorate([
        Action(GenerateTree),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, GenerateTree]),
        __metadata("design:returntype", void 0)
    ], TreeViewState.prototype, "generateTree", null);
    __decorate([
        Action(SortTree),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, SortTree]),
        __metadata("design:returntype", void 0)
    ], TreeViewState.prototype, "sortTree", null);
    __decorate([
        Action(GenerateHistory),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, GenerateHistory]),
        __metadata("design:returntype", void 0)
    ], TreeViewState.prototype, "generateHistory", null);
    __decorate([
        Action(ObjectSelect),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, ObjectSelect]),
        __metadata("design:returntype", void 0)
    ], TreeViewState.prototype, "objectSelect", null);
    __decorate([
        Selector(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], TreeViewState, "getObjects", null);
    __decorate([
        Selector(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], TreeViewState, "getHistory", null);
    __decorate([
        Selector(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Object)
    ], TreeViewState, "getObjectSelected", null);
    TreeViewState = __decorate([
        State({
            name: 'tree',
            defaults: {
                objects: [],
                history: [],
                objectSelected: {},
            },
        }),
        __metadata("design:paramtypes", [ObjectSortingService])
    ], TreeViewState);
    return TreeViewState;
}());
export { TreeViewState };
//# sourceMappingURL=tree-view.state.js.map